dcdg 1.3.1

  • README.md
  • CHANGELOG.md
  • Installing
  • Versions
  • 84

Build Status

Dart Class Diagram Generator #

A small command line utility to generate a class (UML or similar) diagram from a Dart package.

Examples #

Below is a UML diagram of the dcdg source code, created with dcdg. You can find the PlantUML source in the example/ directory.

Example UML Diagram

Installation #

Install from pub:

pub global activate dcdg

Install from clone:

pub global activate -s path .

Usage #

From inside a Dart package repository:

pub global run dcdg

This will dump a PlantUML file to stdout. You can save it to a file instead with the -o option.

See --help for more options, including ways to filter what ends up in the output. You can find the help contents in USAGE.txt as well.

Contributing #

Pull requests are welcome! It is intended to be reasonably straightforward to add a new output format. Take a look at the DOT format implementation in lib/src/builders for an example.

If you have found a bug or have a feature request please open an issue.

Development #

Format code using the tool/format.sh script. It will have a non-zero exit code if the formatting changed. That's fine, it does that so it can be used in CI. Run the full test suite (including unit and functional tests) with tool/check.sh. If you change the user interface or add features you should run tool/docs.sh to regenerate automated documentation and other resources. This script requires PlantUML.

Changelog #

1.0.0 - initial release

1.0.1 - fix bug where tool tried to parse non-Dart files

1.0.2 - improve readme

1.0.3 - add changelog and expand description

1.0.4 - fix bug where --exported-only didn't work

1.0.5 - improve documentation

1.0.6 - export the necessary symbols

1.0.7 - add documentation comments

1.1.0 - add --search option

1.2.0 - fix --exported-only, add --has-a and --is-a

1.3.0 - add aggregation, --exclude-has-a, --exclude-is-a fix bug where exported classes were double-counted

1.3.1 - improve type name output

Use this package as an executable

1. Install it

You can install the package from the command line:


$ pub global activate dcdg

2. Use it

The package has the following executables:


$ dcdg

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  dcdg: ^1.3.1

2. Install it

You can install packages from the command line:

with pub:


$ pub get

with Flutter:


$ flutter pub get

Alternatively, your editor might support pub get or flutter pub get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:dcdg/dcdg.dart';
  
Version Uploaded Documentation Archive
2.0.1 May 25, 2019 Go to the documentation of dcdg 2.0.1 Download dcdg 2.0.1 archive
2.0.0 May 20, 2019 Go to the documentation of dcdg 2.0.0 Download dcdg 2.0.0 archive
1.3.2 May 17, 2019 Go to the documentation of dcdg 1.3.2 Download dcdg 1.3.2 archive
1.3.1 May 17, 2019 Go to the documentation of dcdg 1.3.1 Download dcdg 1.3.1 archive
1.3.0 May 11, 2019 Go to the documentation of dcdg 1.3.0 Download dcdg 1.3.0 archive
1.2.0 May 9, 2019 Go to the documentation of dcdg 1.2.0 Download dcdg 1.2.0 archive
1.1.0 Apr 10, 2019 Go to the documentation of dcdg 1.1.0 Download dcdg 1.1.0 archive
1.0.7 Apr 7, 2019 Go to the documentation of dcdg 1.0.7 Download dcdg 1.0.7 archive
1.0.6 Apr 7, 2019 Go to the documentation of dcdg 1.0.6 Download dcdg 1.0.6 archive
1.0.5 Apr 6, 2019 Go to the documentation of dcdg 1.0.5 Download dcdg 1.0.5 archive

All 15 versions...

Popularity:
Describes how popular the package is relative to other packages. [more]
68
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
100
Overall:
Weighted score of the above. [more]
84
Learn more about scoring.

We analyzed this package on Jun 17, 2019, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.3.2
  • pana: 0.12.18

Platforms

Detected platforms: Flutter, other

Primary library: package:dcdg/dcdg.dart with components: io.

Health suggestions

Fix lib/src/builders/plant_uml_builder.dart. (-0.50 points)

Analysis of lib/src/builders/plant_uml_builder.dart reported 1 hint:

line 68 col 16: 'isUndefined' is deprecated and shouldn't be used.

Maintenance suggestions

Maintain an example.

None of the files in the package's example/ directory matches known example patterns.

Common filename patterns include main.dart, example.dart, and dcdg.dart. Packages with multiple examples should provide example/README.md.

For more information see the pub package layout conventions.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.2.0 <3.0.0
analyzer ^0.36.0 0.36.3
args ^1.5.1 1.5.2
meta ^1.1.7 1.1.7
path ^1.4.1 1.6.2
Transitive dependencies
async 2.2.0
charcode 1.1.2
collection 1.14.11
convert 2.1.1
crypto 2.0.6
csslib 0.16.0
front_end 0.1.18
glob 1.1.7
html 0.14.0+2
kernel 0.3.18
package_config 1.0.5
pub_semver 1.4.2
source_span 1.5.5
string_scanner 1.0.4
term_glyph 1.1.0
typed_data 1.1.6
watcher 0.9.7+10
yaml 2.1.15
Dev dependencies
mockito ^4.0.0
pedantic ^1.0.0
test ^1.0.0